Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 683284 - Gentoo/FreeBSD: removal
Summary: Gentoo/FreeBSD: removal
Status: RESOLVED FIXED
Alias: None
Product: Gentoo/Alt
Classification: Unclassified
Component: FreeBSD (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Deadline: 2019-10-11
Assignee: Gentoo/BSD Team
URL:
Whiteboard:
Keywords: PMASKED
Depends on:
Blocks:
 
Reported: 2019-04-14 07:54 UTC by Michał Górny
Modified: 2019-11-12 15:31 UTC (History)
13 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Michał Górny archtester Gentoo Infrastructure gentoo-dev Security 2019-04-14 07:54:52 UTC
Let's be honest.  The FreeBSD project is on life support.

1. Nobody touches sys-freebsd/*.  I've been applying vulnerability fixes for some time but neglected even that recently.

2. We're behind upstream (at 11.1), with 11.2 and 12.0 being the current upstream versions (and 11.3 approaching).  This is not only bad on security but also makes us hit userland bugs that were fixed in 11.2.

3. The number of failing packages is growing, eliminating whole trees of reverse dependencies.  Some of those are simple regressions that can be fixed upstream.  Some of them are bugs in FreeBSD that were fixed in 11.2.  It doesn't help that FreeBSD people seem to prefer patching stuff locally over submitting bug reports upstream.

4. Finally, I don't think we have anybody really competent with this left.  I don't have time to figure this out.  Patrice's install that I'm using seems buggy at best, and fails horribly while rebuilding/upgrading.  In the end, I can't test my patches properly.

All this considered, I'm seriously wondering if we shouldn't just declare the project dead and start cleaning it up.
Comment 1 Tomáš Mózes 2019-04-14 09:37:29 UTC
Agreed, haven't seen much activity in this area. I've pending bugs waiting for fbsd for months, slowing down other progress.
Comment 2 Larry the Git Cow gentoo-dev 2019-09-11 12:15:16 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=abc856dd8fbce8eae3c3107e4e3c9d08bf141df0

commit abc856dd8fbce8eae3c3107e4e3c9d08bf141df0
Author:     Michał Górny <mgorny@gentoo.org>
AuthorDate: 2019-09-11 12:12:36 +0000
Commit:     Michał Górny <mgorny@gentoo.org>
CommitDate: 2019-09-11 12:15:10 +0000

    package.mask: Last rite sys-freebsd/*
    
    Bug: https://bugs.gentoo.org/683284
    Signed-off-by: Michał Górny <mgorny@gentoo.org>

 profiles/package.mask | 53 ++++++++++++++++++++++++++++++---------------------
 1 file changed, 31 insertions(+), 22 deletions(-)
Comment 3 Michał Górny archtester Gentoo Infrastructure gentoo-dev Security 2019-10-11 15:17:13 UTC
Core packages removed.
Comment 4 Larry the Git Cow gentoo-dev 2019-10-11 15:28:56 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=eabcd8f305610c339887ad3264d5a5c7aab9ff99

commit eabcd8f305610c339887ad3264d5a5c7aab9ff99
Author:     Michał Górny <mgorny@gentoo.org>
AuthorDate: 2019-10-11 15:28:26 +0000
Commit:     Michał Górny <mgorny@gentoo.org>
CommitDate: 2019-10-11 15:28:26 +0000

    package.mask: Last rite dev-libs/libexecinfo, net-analyzer/bsnmp, sys-apps/flock, sys-auth/openpam, sys-block/eject-bsd, sys-process/pidof-bsd
    
    Bug: https://bugs.gentoo.org/683284
    Signed-off-by: Michał Górny <mgorny@gentoo.org>

 profiles/package.mask | 11 +++++++++++
 1 file changed, 11 insertions(+)
Comment 5 Michał Górny archtester Gentoo Infrastructure gentoo-dev Security 2019-10-11 15:57:24 UTC
Profiles and keywords are gone, and the eclass is lastrited.

We still need to clean up '*-fbsd' and 'kernel_FreeBSD' flag use.
Comment 6 Michał Górny archtester Gentoo Infrastructure gentoo-dev Security 2019-10-11 15:58:58 UTC
Hmm, or is kernel_FreeBSD used by prefix maybe?
Comment 7 Fabian Groffen gentoo-dev 2019-10-12 10:00:21 UTC
not anymore because we dropped freebsd targets already a while ago, so feel free to remove
Comment 8 Michał Górny archtester Gentoo Infrastructure gentoo-dev Security 2019-10-12 10:32:26 UTC
(In reply to Fabian Groffen from comment #7)
> not anymore because we dropped freebsd targets already a while ago, so feel
> free to remove

Yeah, I've noticed they're gone but maybe with native *-fbsd users would want them to be reintroduced?
Comment 9 Fabian Groffen gentoo-dev 2019-10-12 10:36:11 UTC
Sorry, I don't understand.  You removed Gentoo/FreeBSD, I removed Prefix/FreeBSD a while ago, so who should still be using kernel_FreeBSD?
Comment 10 Michał Górny archtester Gentoo Infrastructure gentoo-dev Security 2019-10-12 10:51:28 UTC
Let me rephrase: with Gentoo/FBSD gone, wouldn't there be interest in reviving Prefix/FBSD?
Comment 11 Fabian Groffen gentoo-dev 2019-10-12 10:59:53 UTC
Ah, I see.  We killed the port because noone was using/maintaining it.  I guess we can easily bring back the kernel value if we ever want to support FreeBSD again.
Comment 12 Larry the Git Cow gentoo-dev 2019-10-12 12:03:17 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=c24c40206f5ec1f665363ed89d5a46de49eefcce

commit c24c40206f5ec1f665363ed89d5a46de49eefcce
Author:     Michał Górny <mgorny@gentoo.org>
AuthorDate: 2019-10-12 11:57:06 +0000
Commit:     Michał Górny <mgorny@gentoo.org>
CommitDate: 2019-10-12 12:03:08 +0000

    package.mask: Last rite dev-libs/libbegemot
    
    Bug: https://bugs.gentoo.org/683284
    Signed-off-by: Michał Górny <mgorny@gentoo.org>

 profiles/package.mask | 6 ++++++
 1 file changed, 6 insertions(+)
Comment 13 Michał Górny archtester Gentoo Infrastructure gentoo-dev Security 2019-10-12 12:14:54 UTC
Un-bothering prefix@ ;-).

I've reassigned all but this bug, and all packages.

I suppose we may disband the team soonish.
Comment 14 Anton Gubarkov 2019-10-13 17:30:10 UTC
I've noticed that virtual/pam was masked with a reference to this bug. virtual/pam is required by systemd. Is the mask by mistake?
Comment 15 Michał Górny archtester Gentoo Infrastructure gentoo-dev Security 2019-10-13 17:41:50 UTC
@zlogene, please revbump all the ebuilds you've changed dependencies in.
Comment 16 Mikle Kolyada archtester Gentoo Infrastructure gentoo-dev Security 2019-10-13 17:55:18 UTC
(In reply to Michał Górny from comment #15)
> @zlogene, please revbump all the ebuilds you've changed dependencies in.

I avoided bumps here on purpose, because this would turn repository history into hell logically, running  `--oneshot` is more obvious step here.
Comment 17 MickKi 2019-10-13 20:49:25 UTC
(In reply to Mikle Kolyada from comment #16)
> (In reply to Michał Górny from comment #15)
> > @zlogene, please revbump all the ebuilds you've changed dependencies in.
> 
> I avoided bumps here on purpose, because this would turn repository history
> into hell logically, running  `--oneshot` is more obvious step here.

Not working here on stable openrc, after uninstalling the masked virtual/pam:
=====================================================================
# revdep-rebuild -v -- -a
 * This is the new python coded version
 * Please report any bugs found using it.
 * The original revdep-rebuild script is installed as revdep-rebuild.sh
 * Please file bugs at: https://bugs.gentoo.org/
 * Collecting system binaries and libraries
 * Collecting dynamic linking informations
 * Scanning files
 * Checking dynamic linking consistency

Your system is consistent

# emerge -v -a @preserved-rebuild --keep-going

These are the packages that would be merged, in order:

Calculating dependencies... done!

Total: 0 packages, Size of downloads: 0 KiB

Nothing to merge; quitting.
==========================


Cool, all must be good then?
==========================
# emerge --depclean -v -a

 * Always study the list of packages to be cleaned for any obvious
 * mistakes. Packages that are part of the world set will always
 * be kept.  They can be manually added to this set with
 * `emerge --noreplace <atom>`.  Packages that are listed in
 * package.provided (see portage(5)) will be removed by
 * depclean, even if they are part of the world set.
 * 
 * As a safety measure, depclean will not remove any packages
 * unless *all* required dependencies have been resolved.  As a
 * consequence of this, it often becomes necessary to run 
 * `emerge --update --newuse --deep @world` prior to depclean.

Calculating dependencies... done!
 * Dependencies could not be completely resolved due to
 * the following required packages not being installed:
 * 
 *   virtual/pam:0/0= pulled in by:
 *     dev-db/mariadb-10.2.22-r1
 * 
 *   virtual/pam:0/0= pulled in by:
 *     sys-apps/shadow-4.6
 * 
 * Have you forgotten to do a complete update prior to depclean? The
 * most comprehensive command for this purpose is as follows:
 * 
 *   emerge --update --newuse --deep --with-bdeps=y @world
 * 
 * Note that the --with-bdeps=y option is not required in many
 * situations. Refer to the emerge manual page (run `man emerge`)
 * for more information about --with-bdeps.
 * 
 * Also, note that it may be necessary to manually uninstall
 * packages that no longer exist in the repository, since it may not
 * be possible to satisfy their dependencies.

# emerge -uaNDv --with-bdeps=y @world

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild  N    #] virtual/pam-0-r1::gentoo  ABI_X86="(64) -32 (-x32)" 0 KiB

Total: 1 package (1 new), Size of downloads: 0 KiB

The following mask changes are necessary to proceed:
 (see "package.unmask" in the portage(5) man page for more details)
# required by dev-db/mariadb-10.2.22-r1::gentoo
# required by virtual/mysql-5.6-r12::gentoo
# required by kde-apps/akonadi-19.04.3-r1::gentoo
# required by kde-apps/akonadiconsole-19.04.3::gentoo
# required by kde-apps/kdepim-meta-19.04.3::gentoo
# required by @selected
# required by @world (argument)
# /usr/portage/profiles/package.mask:
# Michał Górny <mgorny@gentoo.org> (2019-10-11)
# FreeBSD-only packages.  The project has been discontinued,
# and the core FreeBSD packages are already gone.
# Removal in 14 days.  Bug #683284.
=virtual/pam-0-r1

NOTE: The --autounmask-keep-masks option will prevent emerge
      from creating package.unmask or ** keyword changes.

Would you like to add these changes to your config files? [Yes/No] no
===========================================

'emerge -1av shadow' or any of the above arrives at the same result.  If a package is masked for removal, shouldn't all revdeps have been resolved in portage?
-- 
Regards,
Mick
Comment 18 MickKi 2019-10-13 20:52:33 UTC
Oops! Ignore previous post - I resync'ed portage and revdep packages are emerging now without virtual/pam.
-- 
Regards,
Mick
Comment 19 François Valenduc 2019-10-14 07:01:52 UTC
In reply to the last comment, I ran revdep-rebuild and it didn't find any problem. However, several packages depends on virtual/pam. Do I really have to find al these package myself ?
Comment 20 setun.90 2019-10-14 07:15:32 UTC
I got the news on the masking today. Running `emerge -pc virtual/pam` on my machine which uses systemd lists sys-apps/systemd as pulling in virtual/pam.
Comment 21 François Valenduc 2019-10-14 07:36:11 UTC
I also found shadow, systemd and rstudio (with server flag) now mariadb which depends on virtual/pam. Is there a way to solve all these dependencies at once ?
Comment 22 Devang M 2019-10-14 15:22:28 UTC
Running emerge -1 shadow && emerge -c virtual/pam worked for me.
Comment 23 Kamil Dudka 2019-10-14 15:39:58 UTC
I had to reinstall sys-apps/systemd, dev-db/mariadb, and sys-apps/shadow to prevent emerge from complaining about virtual/pam being masked.
Comment 24 William Hubbs gentoo-dev 2019-10-14 16:59:49 UTC
A quick way to fix all of these dependencies I found yesterday was to
run:

# emerge --changed-deps y -NDuqa @world
# emerge -p --depclean
# emerge --depclean

That should do it.

William
Comment 25 Michael Hofmann 2019-10-16 19:51:22 UTC
Developers, please write NEWS items if you make changes like that.

Look at https://forums.gentoo.org/viewtopic-p-8379896.html

I'm not against removing virtual/pam. But please tell users what you are doing. Otherwise users could run in serious and unnecessary trouble. And I'm sure more reports like that will follow.
Comment 26 mercuriete 2019-10-17 17:54:09 UTC
(In reply to Michael Hofmann from comment #25)
> Developers, please write NEWS items if you make changes like that.
> 
> Look at https://forums.gentoo.org/viewtopic-p-8379896.html
> 
> I'm not against removing virtual/pam. But please tell users what you are
> doing. Otherwise users could run in serious and unnecessary trouble. And I'm
> sure more reports like that will follow.

Totally agree with that

At least an small NEWS to point it out where to find this information.

Thanks for your work, it is amazing.

:)
Comment 27 Mikle Kolyada archtester Gentoo Infrastructure gentoo-dev Security 2019-11-03 17:14:23 UTC
All packages have been removed
Comment 28 Larry the Git Cow gentoo-dev 2019-11-12 15:31:12 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=1bfdf6f9488dce6765acbdc26fc72ae3848c3c40

commit 1bfdf6f9488dce6765acbdc26fc72ae3848c3c40
Author:     Aaron Bauman <bman@gentoo.org>
AuthorDate: 2019-11-12 15:27:22 +0000
Commit:     Aaron Bauman <bman@gentoo.org>
CommitDate: 2019-11-12 15:27:22 +0000

    dev-libs/libbegemot: drop last-rited package
    
    Closes: https://bugs.gentoo.org/683284
    
    Signed-off-by: Aaron Bauman <bman@gentoo.org>

 dev-libs/libbegemot/Manifest               |  1 -
 dev-libs/libbegemot/libbegemot-1.11.ebuild | 23 -----------------------
 dev-libs/libbegemot/metadata.xml           |  5 -----
 profiles/package.mask                      |  6 ------
 4 files changed, 35 deletions(-)